package dal

// This file contains Hl structs for Data Access Layer

//#region ======== HLOGGER ERRORS ========

//#region ======== Common ========

type ErrorType struct {
	Err error
}

type ErrorDalNewClient ErrorType
type ErrorDalUnableToConnect ErrorType
type ErrorDalPingFailed ErrorType
type ErrorDalDisconnectFailure ErrorType
type ErrorDalInit ErrorType

//#endregion

//#region ======== Postgre SQL ========

//#endregion

//#region ======== MongoDB ========

type ErrorInsertQuote ErrorType
type ErrorUpdateQuote ErrorType
type ErrorDeleteQuote ErrorType
type ErrorGetQuote ErrorType

type ErrorGetQuoteList ErrorType

//#endregion
//#endregion

//#region ======== HLOGGER INFO ========

//#region ======== MongoDB ========

type InfoInsertQuote InfoType
type InfoUpdateQuote InfoType
type InfoDeleteQuote InfoType
type InfoGetQuote InfoType

type InfoGetQuoteList InfoType

//#endregion

//#region ======== Common ========

type InfoType struct{}

type InfoDalConnected InfoType
type InfoDalDisconnected InfoType
type InfoDalInit struct {
	Result string
}

type InfoDalPing struct {
	Delay int64 // Milliseconds
}

//#endregion

//#endregion
